<?php

namespace app\models;

use Yii;
use yii\helpers\VarDumper;

/**
 * This is the model class for table "mantu_n".
 *
 * @property int $id
 * @property int $id_child
 * @property string $date_to
 * @property string $pred_diagnoz
 * @property string $date_osmotr_ptd
 * @property string $finish_diagnoz_ptd
 * @property int $status_ptd
 * @property string $date_sled_yavki
 * @property string $medotvod
 * @property string $date_vidacha
 * @property string $coment
 *
 * @property Deti $child
 */
class MantuN_new extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'mantu_n';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['id_child'], 'required'],
            [['id_child', 'status_ptd'], 'integer'],
            [['date_to', 'date_osmotr_ptd', 'date_sled_yavki', 'medotvod', 'date_vidacha'], 'safe'],
            [['pred_diagnoz', 'finish_diagnoz_ptd'], 'string', 'max' => 100],
            [['coment'], 'string', 'max' => 1000],
            [['id_child', 'date_to'], 'unique', 'targetAttribute' => ['id_child', 'date_to']],
//            [['id_child'], 'exist', 'skipOnError' => true, 'targetClass' => Deti::className(), 'targetAttribute' => ['id_child' => 'id']],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'id_child' => 'Id Child',
            'date_to' => 'Date To',
            'pred_diagnoz' => 'Pred Diagnoz',
            'date_osmotr_ptd' => 'Date Osmotr Ptd',
            'finish_diagnoz_ptd' => 'Finish Diagnoz Ptd',
            'status_ptd' => 'Status Ptd',
            'date_sled_yavki' => 'Date Sled Yavki',
            'medotvod' => 'Medotvod',
            'date_vidacha' => 'Date Vidacha',
            'coment' => 'Coment',
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'timestamp' => [
                'class' => \yii\behaviors\TimestampBehavior::class,
                'attributes' => [
                    self::EVENT_BEFORE_INSERT => ['date_to'],
                ],
                'value' => $this->date_to ?? date('Y-m-d'),
            ],
        ];
    }

    /**
     * Gets query for [[Child]].
     *
     * @return \yii\db\ActiveQuery|\app\models\query\DetiQuery
     */
    public function getChild()
    {
        return $this->hasOne(Deti::className(), ['id' => 'id_child']);
    }

    /**
     * {@inheritdoc}
     * @return \app\models\query\MantuNQuery the active query used by this AR class.
     */
    public static function find()
    {
        return new \app\models\query\MantuNQuery(get_called_class());
    }

    public function afterSave($insert, $changedAttributes)
    {
        parent::afterSave($insert, $changedAttributes); // TODO: Change the autogenerated stub

        if(date('Y', strtotime($this->date_sled_yavki)) > 2000){
            $model = new self([
                'id_child' => $this->id_child,
                'date_to' => $this->date_sled_yavki
            ]);

            if (!$model->save()){
                \Yii::error('Unable to save model: ' . VarDumper::dumpAsString($model->getErrors()) . PHP_EOL . VarDumper::dumpAsString($model->getAttributes()), __METHOD__);
            }
        }
    }
}
